
; -------------------------------------------------------------------------------------

Sub_LoadBackground:	tax
			asl
			tay
			lda BackgroundData_Ptrs, Y
			sta DataPtr
			lda BackgroundData_Ptrs + 1, Y
			sta DataPtr + 1
			lda BackgroundData_Lengths, X
			jmp Sub_PushToVramBuffer

BackgroundData_Ptrs:	.dw StatusBar_data, BlankIC_data
BackgroundData_Lengths:	.db $30, $66

StatusBar_data:		.db $20, $20, $07				; top bar
			.db $00, $60, RLE, $1C, $64, $61, $00
			.db $20, $A0, $07				; bottom bar
			.db $00, $62, RLE, $1C, $64, $63, $00
			.db $20, $41, $83				; left bar
			.db $65, $65, $65
			.db $20, $5E, $83				; right bar
			.db $65, $65, $65
			.db $23, $C0, $07				; attribute data
			.db $3F, RLE, $07, $FF, RLE, $08, $0F
			
BlankIC_data:		.db $21, $00, $63
			.db RLE, $04, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00
			.db RLE, $18, $01, RLE, $08, $00

; -------------------------------------------------------------------------------------

Sub_LoadPalette:	tax
			asl
			tay
			lda Palette_Ptrs, Y
			sta DataPtr
			lda Palette_Ptrs + 1, Y
			sta DataPtr + 1
			lda Palette_Lengths, X
			jmp Sub_PushToVramBuffer

Palette_Ptrs:		.dw TitleScreen_pal, GamePlay_pal
Palette_Lengths:	.db $23, $23

TitleScreen_pal:	.db $3F, $00, $20
			.dsb $20
GamePlay_pal:		.db $3F, $00, $20
			.incbin "file\pal\gameplay.pal"

; -------------------------------------------------------------------------------------
;
; Draw a tile to vram.
;
; in:  A=metatile index
;      X=X coor
;      Y=Y coor
;
; out: (none)
;
Sub_LoadICTile:		sta SelTile					; save parameters
			stx SelTile_X					;
			sty SelTile_Y					;

			lda #00						;
			sta add_16bit					;
			sta add_16bit + 1				;

			lda SelTile_Y					; get vram dest offest
			and #$0F					;
			rol						;   -adjust for row
			rol						;
			rol						;
			rol						;
			rol						;
			rol add_16bit + 1				;
			rol						;
			rol add_16bit + 1				;
			sta add_16bit					;
			lda SelTile_X					;   -adjust for column
			asl						;
			clc						;
			adc add_16bit					;
			sta add_16bit					;
			lda add_16bit + 1				;   -keep carry
			adc #00						;
			sta add_16bit + 1				;
									;
			lda #$04					; write vram addresses
			clc						;
			adc add_16bit					;
			sta TileWriter_vramdest_0 + 1			;
			lda #$21					;
			adc add_16bit + 1				;
			sta TileWriter_vramdest_0			;
									;
			lda #$24					;
			clc						; this implemenation keeps the result
			adc add_16bit					;   in the A and Y register
			sta TileWriter_vramdest_1 + 1			;
			lda #$21					;
			adc add_16bit + 1				;
			sta TileWriter_vramdest_1			;
									;
			lda #02						; write ctrl bytes
			sta TileWriter_ctrl_0				;
			sta TileWriter_ctrl_1				;

			lda SelTile					; get metatile data offset
			asl						;
			asl						;
			tay						;
	
			lda Metattile_data, Y				; write metatile data	(top)
			sta TileWriter_data_0				;
			lda Metattile_data + 1, Y			;
			sta TileWriter_data_0 + 1			;
			lda Metattile_data + 2, Y			;	(bottom)
			sta TileWriter_data_1				;
			lda Metattile_data + 3, Y			;
			sta TileWriter_data_1 + 1			;

			lda #<TileWriter_Array				; set vram buffer transfer
			sta DataPtr					;   arguments
			lda #>TileWriter_Array				;
			sta DataPtr + 1					;
			lda #10						;
			jmp Sub_PushToVramBuffer			;

Metattile_data:
ic_00_blank:		.hex 0101	;      |  |
			.hex 0101	;      |  |

ic_01:			.hex C0C0	; [in] |--|
			.hex 0101	;      |  |
	
ic_02:			.hex 0101	;      |  |
			.hex C0C0	; [in] |--|
	
ic_03:			.hex C0C0	; [in] |--|
			.hex C0C0	; [in] |--|

ic_04:			.hex 0101	; [in] |__|
			.hex C5C5	;      |  |

ic_05:			.hex C0C0	; [in] |--|
			.hex C1C0	;      |,-|
					;     [in]

					;     [in]
ic_06:			.hex C2C0	;      |'-|
			.hex C0C0	; [in] |--|
	
					;     [in]
ic_07:			.hex C301	;      |' |
			.hex 0101	;      |  |

ic_08:			.hex 0101	;      |  |
			.hex C401	;      |, |
					;     [in]

					;     [in]
ic_09:			.hex C2C0	;      |'-|
			.hex 0101	;      |  |

ic_0A:			.hex 0101	;      |  |
			.hex C1C0	;      |,-|
					;     [in]

					;     [in]
ic_0B:			.hex C2C0	;      |'-|
			.hex C1C0	;      |,-|
					;     [in]

ic_0C:			.hex 0101	;       |_  |
			.hex C5C6	; [OUT] | '-| [IN]

ic_0D:			.hex 01C8	;       |_,-| [IN]
			.hex C5C7	; [OUT] |   |

ic_0E:			.hex 0101	;       |_  |
			.hex C901	; [OUT] | ' |
					;       [in]

					;       [in]
ic_0F:			.hex CB01	;       |_' |
			.hex CA01	; [OUT] |   |
			
					;     [in]
ic_10:			.hex C2C0	;      |'-|
			.hex C6C0	; [in] |\-|
			
ic_11:			.hex C8C0	; [in] |/-|
			.hex CCC0	;      |,-|
					;     [in]

ic_12_AND:		.hex 8081	; =[)-
			.hex 9091	;
ic_13_OR:		.hex 8283	; =)>-
			.hex 9293	;
ic_14_NOT:		.hex 8485	; =|>o-
			.hex 9495	;
ic_15_NAND:		.hex A0A1	; =[)o-
			.hex B0B1	;
ic_16_NOR:		.hex A2A3	; =)>o-
			.hex B2B3	;
ic_17_XOR:		.hex A4A5	; =))>-
			.hex B4B5	;
ic_18_XNOR:		.hex A6A7	; =))>o-
			.hex B6B7	;

