;	http://en.wikipedia.org/wiki/Logic_gate#Symbols
;
;
;
;     AND  =[)-	INPUT OUTPUT 
;	A B   A AND B 
;	0 0      0 
;	0 1      0 
;	1 0      0 
;	1 1      1 
;
;     OR   =)>-	INPUT OUTPUT 
;	A B   A OR B 
;	0 0      0 
;	0 1      1 
;	1 0      1 
;	1 1      1 
;
;     NOT  =|>o-	INPUT OUTPUT 
;	  0      1
;	  1      0 
;
;     NAND =[)o-	INPUT OUTPUT 
;	A B   A AND B 
;	0 0      1 
;	0 1      1 
;	1 0      1 
;	1 1      0
;
;     NOR  =)>o-	INPUT OUTPUT 
;	A B   A OR B 
;	0 0      1 
;	0 1      0 
;	1 0      0 
;	1 1      0 
;
;     XOR  =))>-	INPUT OUTPUT 
;	A B   A OR B 
;	0 0      0 
;	0 1      1 
;	1 0      1 
;	1 1      0 
;
;     XNOR =))>o-	INPUT OUTPUT 
;	A B   A OR B 
;	0 0      1 
;	0 1      0 
;	1 0      0 
;	1 1      1 

Sub_Gameplay:		jsr Sub_ClearVram

			lda #1
			jsr Sub_LoadPalette
			lda #0
			jsr Sub_LoadBackground
			jsr Sub_WriteVramBuffer
			lda #1
			jsr Sub_LoadBackground
			jsr Sub_WriteVramBuffer
			
			lda #00
			jsr Sub_SetMenuPtrs

			jsr Sub_TurnOnScreen

_gameplayLoop:		lda Plyr_JoypadOld				; get new button presses
			eor #$FF					;
			and Plyr_JoypadCur				;
			sta Plyr_JoypadNew				;
									; handle button presses
			lda Plyr_JoypadCur				; [B]
			and #BUTTON_B					;
			beq +++						;
				lda Plyr_JoypadNew			;   [+UP]
				and #BUTTON_UP				;
				beq ++					;
					inc CurrentTile_id		;
					lda CurrentTile_id		;
					cmp #ICCOUNT			;
					bcc +				;
						lda #0			;
					sta CurrentTile_id		;
+					jmp _gp_FinishDirButtons	;
++									;
									;
				lda Plyr_JoypadNew			;   [+DOWN]
				and #BUTTON_DOWN			;
				beq ++					;
					dec CurrentTile_id		;
					bpl +				;
						lda #(ICCOUNT - 1)	;
						sta CurrentTile_id	;
+					jmp _gp_FinishDirButtons	;
++									;
+++									;
									;
			lda Plyr_JoypadNew				; [UP]
			and #BUTTON_UP					;
			beq +						;
				jsr Sub_DecCurY				;
				jmp _gp_FinishDirButtons		;
+									;
									;
			lda Plyr_JoypadNew				; [DOWN]
			and #BUTTON_DOWN				;
			beq +						;
				jsr Sub_IncCurY				;
				jmp _gp_FinishDirButtons		;
+									;
									;
			lda Plyr_JoypadNew				; [LEFT]
			and #BUTTON_LEFT				;
			beq +						;
				jsr Sub_DecCurX				;
				jmp _gp_FinishDirButtons		;
+									;
									;
			lda Plyr_JoypadNew				; [RIGHT]
			and #BUTTON_RIGHT				;
			beq +						;
				jsr Sub_IncCurX				;
				jmp _gp_FinishDirButtons		;
+									;
									;		
			lda Plyr_JoypadNew				; [SELECT]
			and #BUTTON_SELECT				;
			beq +						;
				jsr Sub_ClearMetatile			;
				jmp _gp_FinishDirButtons		;
+									;
									;
			lda Plyr_JoypadNew				; [A]
			and #BUTTON_A					;
			beq +						;
				jsr Sub_ChangeMetatile			;
_gp_FinishDirButtons:		lda Plyr_JoypadCur			; set (OldButtons == CurButtons)
				sta Plyr_JoypadOld			;  [no new presses 'til next frame]
+									;
									;
			jsr Sub_UpdateGPCursorPos			; update cursor
			jsr Sub_DrawCurrentIC				; update current IC
			lda #TRUE					; end of frame
			sta frameFinished				;
-			lda frameFinished				;   wait until vblank clears flag
			bne -						;
			jmp _gameplayLoop				; loop gamplay

;--------------------------------------------------------------------------------------------------

Sub_DrawCurrentIC:	lda CurrentTile_id				;
			asl						;
			asl						;
			tay						;
									;
			lda #FALSE					;
			sta writeBufferToVram				;
			ldx vramBufferPtr				;
									;
			lda #$20					; write metatile data	(top)
			sta VramBuffer, X				;
			dex						;
			lda #$42					;
			sta VramBuffer, X				;
			dex						;
			lda #$02					;
			sta VramBuffer, X				;
			dex						;
			lda Metattile_data, Y				;
			sta VramBuffer, X				;
			dex						;
			lda Metattile_data + 1, Y			;
			sta VramBuffer, X				;
			dex						;
			lda #$20					;	(bottom)
			sta VramBuffer, X				;
			dex						;
			lda #$62					;
			sta VramBuffer, X				;
			dex						;
			lda #$02					;
			sta VramBuffer, X				;
			dex						;
			lda Metattile_data + 2, Y			;
			sta VramBuffer, X				;
			dex						;
			lda Metattile_data + 3, Y			;
			sta VramBuffer, X				;
			dex						;
									;
			stx vramBufferPtr				;
			lda #TRUE					;
			sta writeBufferToVram				;
			rts						;

;--------------------------------------------------------------------------------------------------

Sub_UpdateGPCursorPos:	ldy CursorCoorY					; set Y coordinates
			lda gameplay_curCoorY, Y			;
			sta CursorSprite				;
			sta CursorSprite + 4				;
			clc						;
			adc #08						;
			sta CursorSprite + 8				;
			sta CursorSprite + 12				;
			lda CursorAnimation				; set tile index
			rol						;
			rol						;
			rol						;
			and #%00000011					;
			asl						;
			asl						;
			ora #CURSOR_TILE_START				;
			tax						;
			stx CursorSprite + 1				;
			inx						;
			stx CursorSprite + 5				;
			inx						;
			stx CursorSprite + 9				;
			inx						;
			stx CursorSprite + 13				;
			lda #CURSOR_ATT					; set attribute
			sta CursorSprite + 2				;
			sta CursorSprite + 6				;
			sta CursorSprite + 10				;
			sta CursorSprite + 14				;
			ldx CursorCoorX					; set X coordinates
			lda gameplay_curCoorX, X			;
			sta CursorSprite + 3				;
			sta CursorSprite + 11				;
			clc						;
			adc #08						;
			sta CursorSprite + 7				;
			sta CursorSprite + 15				;
			rts						;

gameplay_CursorData:	.db $07, $0B
gameplay_curCoorY:	.db $40, $50, $60, $70, $80, $90, $A0, $B0
gameplay_curCoorX:	.db $20, $30, $40, $50, $60, $70, $80, $90, $A0, $B0, $C0, $D0

;--------------------------------------------------------------------------------------------------

Sub_ClearMetatile:	ldx CursorCoorY					; get offset into IC array
			lda icArray_offsets, X				;
			clc						;
			adc CursorCoorX					;
			tax						;
			lda #0						; redraw tile
			sta IC_TileArray, X				;
			ldx CursorCoorX					;
			ldy CursorCoorY					;
			jmp Sub_LoadICTile				;


Sub_ChangeMetatile:	ldx CursorCoorY					; get offset into IC array
			lda icArray_offsets, X				;
			clc						;
			adc CursorCoorX					;
			tax						;
			lda CurrentTile_id				; redraw tile
			sta IC_TileArray, X				;
			ldx CursorCoorX					;
			ldy CursorCoorY					;
			jmp Sub_LoadICTile				;

icArray_offsets:	.db ROWSIZE * 0, ROWSIZE * 1, ROWSIZE * 2, ROWSIZE * 3
			.db ROWSIZE * 4, ROWSIZE * 5, ROWSIZE * 6, ROWSIZE * 7

;--------------------------------------------------------------------------------------------------

Sub_ClearICTileArray:	lda #00
			tax
_clearIC_loop:		sta IC_TileArray, X				; clear IC pieces data
			inx						;
			cpx #BOARDSIZE					;
			bcc _clearIC_loop				;   loop if(X < #96)
			rts

